variables:
  TF_ROOT:
    value: '.aws/terraform'
    description: The root directory of the terraform project.
  TF_DESTROY:
    value: 'false'
    description: Whether to enable the destroy job.
  WORKSPACE:
    value: $CI_COMMIT_REF_SLUG
    description: The environment to deploy to.

include:
  - project: ben_goodman/utility/pipeline_templates
    file:
      - recipes/deploy_react_app.gitlab-ci.yml

default:
  image: registry.gitlab.com/ben_goodman/utility/images/nodejs-builder-20.5.1:stable
  tags:
    - linux
    - md


Apply Terraform:
  after_script:
    - |
      cd $CI_PROJECT_DIR/$TF_ROOT
      {
        echo "S3_BUCKET_NAME=$(terraform output --raw default_s3_bucket_name)"
        echo "CLOUDFRONT_DIST_ID=$(terraform output --raw cloudfront_id)";
      } > "$CI_PROJECT_DIR/terraform_output.env"
  artifacts:
    reports:
      dotenv: terraform_output.env

Build App:
  needs:
    - Apply Terraform


Release App:
  after_script:
    - echo "cloudfront create-invalidation --distribution-id $CLOUDFRONT_DIST_ID --paths '/index.html'"
  needs:
    - Build App
    - Apply Terraform
